#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>

void kernel(unsigned int rows, unsigned int cols , int cRows , int contRows ,unsigned char *snpdata,float *results){

        unsigned char y;
        int m, n ;
        unsigned int p = 0 ;
        int cases[3];
        int controls[3];
        int tot_cases = 1;
        int tot_controls= 1;
        int total = 1;
        float chisquare = 0.0f;
        float exp[3];
        float Conexpected[3];
        float Cexpected[3];
        float numerator1;
        float numerator2;
	unsigned int tid=0;

 	for(tid = 0; tid < cols; tid++) {
		
		chisquare=0;
	        cases[0]=1;cases[1]=1;cases[2]=1;
        	controls[0]=1;controls[1]=1;controls[2]=1;

	        for ( m = 0 ; m < cRows ; m++ ) {
        	        y = snpdata[(size_t) ((size_t) m) * ((size_t) cols) + tid];
                	if ( y == '0') { cases[0]++; }
	                else if ( y == '1') { cases[1]++; }
        	        else if ( y == '2') { cases[2]++; }
	        }

		for ( n = cRows ; n < cRows + contRows ; n++ ) {
	                y = snpdata[(size_t) ((size_t) n) * ((size_t) cols) + tid];
        	        if ( y == '0' ) { controls[0]++; }
                	else if ( y == '1') { controls[1]++; }
	                else if ( y == '2') { controls[2]++; }
        	}

		tot_cases = cases[0]+cases[1]+cases[2];
        	tot_controls = controls[0]+controls[1]+controls[2];
	        total = tot_cases + tot_controls;

	        for( p = 0 ; p < 3; p++) {
        	        exp[p] = (float)cases[p] + controls[p];
                	Cexpected[p] = tot_cases * exp[p] / total;
	                Conexpected[p] = tot_controls * exp[p] / total;
        	        numerator1 = (float)cases[p] - Cexpected[p];
                	numerator2 = (float)controls[p] - Conexpected[p];
	                chisquare += numerator1 * numerator1 / Cexpected[p] +  numerator2 * numerator2 / Conexpected[p];
        	}

	        results[tid] = chisquare;
	}
}

int main(int argc ,char* argv[]) {

	FILE *fp;
	size_t size;
	  
	/* Initialize rows, cols, ncases, ncontrols from the user */
	int rows=atoi(argv[2]);
	int cols=atoi(argv[3]);
	int ncases=atoi(argv[4]);
	int ncontrols=atoi(argv[5]);
	printf("Individuals=%d SNPs=%d cases=%d controls=%d\n",rows,cols,ncases,ncontrols);

	fflush(stdout);

	float* host_results = (float*) malloc(cols*sizeof(float));

        struct timeval starttime, endtime;
	float seconds, seconds2;

	unsigned int jobs; 
	unsigned long ulone = 1;
	unsigned long ultwo = 2; 
	unsigned long i;
	int k, tmp, cur, read;

	char *line = NULL; size_t len = 0;
	char *token, *saveptr;

	/*Kernel variable declaration */
	unsigned char *dev_dataT;

	/* Validation to check if the data file is readable */
	fp = fopen(argv[1], "r");
	if (fp == NULL) {
	    	printf("Cannot Open the File");
		return 0;
	}

	size = (size_t)((size_t)rows * (size_t)cols);
	printf("Size of the data = %lu\n",size);

	fflush(stdout);

	unsigned char *dataT = (unsigned char*)malloc((size_t)size);

	if(dataT == NULL) {
        	printf("ERROR: Memory for data not allocated.\n");
	}

        gettimeofday(&starttime, NULL);

	/* Transfer the SNP Data from the file to CPU Memory */
	i=0; 
	while (getline(&line, &len, fp) != -1) {
		token = strtok_r(line, " ", &saveptr);
		while(token != NULL){
	                dataT[i] = *token;
                        i++;
			token = strtok_r(NULL, " ", &saveptr);
                }
/*
		cur=0; read=-1;
		token = strtok(line, " ");		
		while(sscanf(line+cur, "%d%n", &tmp, &read)==1){
	                dataT[i] = (char)(((int)'0')+tmp);
			cur += read;
			i++;
		}
*/
	}	
	fclose(fp);
	printf("read data\n");
	fflush(stdout);

        gettimeofday(&endtime, NULL); 
	seconds+=((double)endtime.tv_sec+(double)endtime.tv_usec/1000000)-((double)starttime.tv_sec+(double)starttime.tv_usec/1000000);

	printf("time to read data = %f\n", seconds);

/*
        gettimeofday(&starttime, NULL);
	for(i=0 ; i < size; i++ ) {
		fscanf(fp,"%d",&tmp);
		dataT[i] = (char)(((int)'0')+tmp);
	} 
	fclose(fp);
        gettimeofday(&endtime, NULL); seconds=((double)endtime.tv_sec+(double)endtime.tv_usec/1000000)-((double)starttime.tv_sec+(double)starttime.tv_usec/1000000);
        printf("time to read data = %f\n", seconds);
*/

	printf("calling kernel\n");
	fflush(stdout);

        gettimeofday(&starttime, NULL);
	/*Calling the kernel function */
	kernel(rows,cols,ncases,ncontrols,dataT,host_results);
        gettimeofday(&endtime, NULL); seconds=((double)endtime.tv_sec+(double)endtime.tv_usec/1000000)-((double)starttime.tv_sec+(double)starttime.tv_usec/1000000);
        printf("time for kernel=%f\n", seconds);
		
	fflush(stdout);

	for(k = 0; k < cols; k++) {
		printf("%f ", host_results[k]);
	}
	printf("\n");

	return 0;

}
